package com.jwipc.sys.controller.pc;

import com.jwipc.page.PageView;
import com.jwipc.sys.dto.FileResposeDTO;
import com.jwipc.sys.dto.SysConfigDTO;
import com.jwipc.sys.logic.SysConfigLogic;
import com.jwipc.sys.model.query.SysConfigQuery;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

import static com.jwipc.sys.constant.ModuleConst.MODULE_ROOT;

/**
 * @author shenyang.ou
 * @date 2024/2/2 16:52
 * @desc 系统配置
 */
@RestController
@RequestMapping(MODULE_ROOT + "/sysConfig/rest")
@RequiredArgsConstructor
public class SysConfigRestController {
    private final SysConfigLogic sysConfigLogic;

    /**
     * 列表
     * @param query
     * @return
     */
    @RequestMapping("/list")
    public PageView list(SysConfigQuery query) {
        return sysConfigLogic.findByPage(query);
    }


    /**
     * 列表
     * @param query
     * @return
     */
    @RequestMapping("/listAll")
    public List<SysConfigDTO> listAll(SysConfigQuery query) {
        return sysConfigLogic.listAll(query);
    }

    /**
     * 保存更新
     *
     * @param param 参数
     */
    @PostMapping("/saveOrUpdate")
    public ResponseEntity saveOrUpdate(SysConfigDTO param) {
        sysConfigLogic.saveOrUpdate(param);
        return ResponseEntity.ok(true);
    }

    /**
     * 配置数据状态更新
     *
     * @param ids    配置数据的ID集合
     * @param status 变更的状态 0:启用 1:禁用
     * @return 结果
     */
    @PostMapping("/status/update")
    public ResponseEntity updateStatus(String ids, Integer status) {
        sysConfigLogic.updateStatus(ids,status);
        return ResponseEntity.ok(true);
    }

    /**
     * 删除
     *
     * @param ids 参数
     */
    @PostMapping("/batchRemove")
    public ResponseEntity batchRemove(String ids) {
        sysConfigLogic.batchRemove(ids);
        return ResponseEntity.ok(true);
    }

    /**
     * 获取文本型系统参数
     * @param key 唯一编码
     * @return 参数
     */
    @GetMapping("/getTextConfig")
    public String getTextConfig(String key) {
        return sysConfigLogic.getTextConfig(key);
    }

    /**
     * 获取附件型文件
     *
     * @param key 唯一编码
     * @return 文件
     */
    @GetMapping("/getFileConfig")
    public FileResposeDTO getFileConfig(String key) {
        return sysConfigLogic.getFileConfig(key);
    }

    /**
     * 获取单选型系统参数
     *
     * @param key 唯一编码
     * @return 参数 0-否；1-是
     */
    @GetMapping("/getRadioConfig")
    public Integer getRadioConfig(String key) {
        return sysConfigLogic.getRadioConfig(key);
    }
}
